#include <stdio.h>
/*#include <stdlib.h>
#include <unistd.h>
#include <sys/io.h>*/

#define base 0x378           /* printer port base address */

int controlsw(int altwert)
{
	int neuwert;
	/* 
	Am den Control-Ausgaengen des Parallelport sind einige Ausgaenge negiert.
	Zum einfacheren Verstaendnis werden im Programm die Daten "richtig herum" verwendet
	und dann nur hier umgerechnet
	
	1011 binaer = 11 dezimal
	8 = Select in (negiert) - Angeschlossen an IC Pin 15 (Output Enable)
	4 = init (nicht negiert) - Angeschlossen an IC Pin 1 (Strobe) - Speichert die angelegten Werte im IC
	2 = Autofeed (negiert) - Anschlossen an IC Pin 3 (Clock) - Schiebt die Daten in den Schieberegistern weiter
	1 = Strobe (negiert) - Angeschlossen an den IC # 17 an Pin 2 (Eingang) ber die anderen Datenausgnge knnen nur 8 (16) ICs angesteuert werden.
	*/
	neuwert = (altwert ^ 11);
	return neuwert;
}

void blinkout(int frame[8][18], int screenout)  
{ 
	int dataport = (int)base;
	int controlport= (dataport+2) ;
	int aktzeile,aktspalte;
	int data, data2;
	int durchlauf;
/*	
* zu Testzwecken kann diese Routine benutzt werden, die den aktuellen Frame auch auf
* dem Bildschirm ausgibt
*/
	if (screenout==1)
	{
		clrscr();
		for (aktzeile=0; aktzeile<8; aktzeile++)
		{
			for (aktspalte=0;aktspalte<18;aktspalte++)
			{
				printf("%d",frame[aktzeile][aktspalte]);
			}
			printf("\n\r");
		}
	}
	for (durchlauf=0 ; durchlauf<=1; durchlauf++)
	{
		
		outb(controlport,controlsw(0));
		for (aktzeile=7 ; aktzeile>=0 ; aktzeile--)
		{
			data=0;
			data2=0; 
			/* dies ist fuer den IC 17, da dieser speziell ueber Strobe beschaltet werden muss
			* im VB-Programm war dies noch invertiert. hier wird er direkt verwendet.
			* (0 = Licht aus, 1 = Licht an)
			* Fuer die Umrechnung haben wir eine extra Routine.
			*/
			for (aktspalte=(1-durchlauf) ; aktspalte<=15 ; aktspalte=aktspalte+2)
			{
				if (frame[aktzeile][aktspalte]==1)
				{
					data=data+(1<<(aktspalte/2));
					/*printf("1");*/
				}
				else
				{
					/*printf("0");*/
				}
			}
			if (frame[aktzeile][17-durchlauf]==1)
			{
				data2=1;
			}
			else
			{
				data2=0;
			}
			outb(dataport,data);
			/* Hiermit werden die ersten 8 ICs belegt */
			usleep(3);
			outb(controlport,controlsw(data2));
			/* 
			* 000X (nur evtl Strobe=Data17)
			* Hiermit wird auch der Wert fuer den letzten IC gespeichert 
			*/
			usleep(3);
			outb(controlport,controlsw(2+data2));
			/* 
			* 001X (AutoFeed=Clock + evtl Strobe=Data17)
			* Hiermit wird ueber den AutoFeed-Ausgang der Clock-Eingang der ICs angesprochen
			* und somit die Daten weiterverschoben
			*/
			usleep(3);
		}
	}
	outb(controlport,controlsw(5));
	/*
	* 0101 (Init=Strobe + Strobe=Data17) - 
	* mir ist nicht ganz klar, warum ab hier Strobe=Data17 immer gesetzt wird.
	* Ich vermute einfach mal, dass es dort egal ist, weil eh bis zur Ausgabe kein Clock-Signal mehr erfolgt.
	*	
	* Hier wird ueber den Init-Ausgang der Strobe-Eingang der ICs angesprochen
	* Damit werden die in den ICs gepspeicherten Daten zur Ausgabe bereit gemacht
	*/
	usleep(3);
	outb(controlport,controlsw(1));
	/* 
	* 0001 (Strobe=Data17)
	* Hier wird der Eingang wieder zurueck genommen 
	*/
	usleep(3);
	outb(controlport,controlsw(9));
	/* 
	* 1001 (SelectIn=OutputEnable + Strobe=Data17)
	* Hier wird der OutputEnable-Eingang der Chips aktiviert und sie geben ihre Daten an ihre
	* Pinne weiter. Die daran angeschlossenen LEDs fangen an zu leuchten.
	*/
	usleep(3);
}

